#ifndef MINIGAME_H_INCLUDED
#define MINIGAME_H_INCLUDED
#include <windows.h>

extern int g_window_width;
extern int g_window_height;

extern int g_player_width;
extern int g_player_height;
extern int g_player_x;
extern int g_player_y;

typedef enum {
  STONE_FALLING_OBJECT,
  FOODCHOPPER_FALLING_OBJECT,
  BALL_FALLING_OBJECT,
  SCISSORS_FALLING_OBJECT
} FallingObjectKind;

typedef struct {
  double real_y;
  double velocity;
} FoodChopper;

typedef struct {
  double real_x;
  double x_vector;
} Ball;
#define BALL_SPEED (5)

typedef struct {
  int center_x;
  int animation_counter;
  int now_openning;
} Scissors;

typedef struct FallingObject_tag {
  FallingObjectKind kind;
  int x;
  int y;
  int width;
  int height;
  int prev_x;
  int prev_y;
  int prev_width;
  int prev_height;
  HBITMAP bitmap;
  union {
    FoodChopper foodchopper;
    Ball ball;
    Scissors scissors;
  } u;
  struct FallingObject_tag *next;
} FallingObject;

extern FallingObject *g_falling_object_top;
extern FallingObject *g_falling_object_tail;

/* main.c */
void draw_bitmap(HWND hwnd, HBITMAP hbmp, int x, int y, int width, int height);
void fill_black_rectangle(HWND hwnd, int x, int y, int width, int height);

/* fallingobjects.c */
void initialize_falling_objects(void);
void draw_falling_objects(HWND hwnd);
void move_falling_objects(void);
int check_crash(int x, int y, int width, int height);

#endif /* MINIGAME_H_INCLUDED */
